module MyPCalc0 where

import Parsec
import MyGeneral


-- Ein Parser fuer ein Zeichen von a bis z 
-- parseTest simple0 "abc123" --'a'
simple0 :: Parser Char
simple0  = letter

-- Ein Parser fuer Identifier
-- parseTest simple1 "abc123" -- "abc"
simple1 :: Parser [Char]
simple1  = many letter

-- Ein Parser fuer Hex Zahlen
-- parseTest simple2 "ABC123xyz" -- "ABC123"
simple2 :: Parser [Char]
simple2  = many hexDigit

-- #####################
-- Sequenz and choice
-- #####################
openClose0 :: Parser Char
openClose0  =  do{ char '('
		 ; char ')' 
		 }
-- parseTest openClose1 "(())"
-- parseTest openClose1 "(()"
openClose1 :: Parser ()
openClose1  = do{ char '('
		; openClose1
		; char ')'
		; openClose1
		}
	      <|> return ()

-- #####################
-- Predictive parsers
-- #####################
-- parseTest or0 "(a)" -- "(a)"
-- parseTest or0 "(b)" 
or0 = string "(a)" 
      <|> 
      string "(b)"

-- parseTest or1 "(a)" -- "ok"
-- parseTest or1 "(b)" -- "ok"
or1 = do { char '('
	 ; char 'a' <|> char 'b'
	 ; char ')'
	 ; return "ok"  
	 }
-- parseTest or2 "(a)" -- "(a)"
-- parseTest or2 "(b)" -- "(b)"
-- parseTest or2 "(c)"
or2 = try( string "(a)" )
      <|>
      try( string "(b)" )

-- #####################
-- adding semantic
-- #####################

-- parseTest noOfBrace "{}{}" -- 2
-- parseTest noOfBrace "{{}}{}" -- 3
noOfBrace = do{ char '{'
		; m <- noOfBrace 
		; char '}'
		; n <- noOfBrace 
		; return (1+m+n);
		}
	      <|> return 0












